#include-once
#include <GDIPlus.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <SendMessage.au3>
#include <Array.au3>
#include <WinAPI.au3>

Global $arrayID[0][6] ;enregistrement des handles: handle du label, handle bouton repos, handle hovers, handle clic, handle disable, id du bouton
Global $test
Global $nix, $hIndex, $iIndex = -1
OnAutoItExitRegister("Net") ;nettoyage des handles
GUIRegisterMsg($WM_SETCURSOR, "WM_SETCURSOR") ;suivi de la souris

; FUNCTIONS ====================================================================================================================
; Name ..........: _ADD_Button
; Name ..........: _ButtonState
; Name ..........: _ButtonDelete
; #FUNCTION# ====================================================================================================================
; Name ..........: _ADD_Button
; Description ...: Cre un pseudo bouton avec couleur, alignement et couleur texte. En surbrillance sous la souris et s'assombrit au clic
; Syntax ........: _ADD_Button($Left, $Top, $width, $height, $Text[, $AlignTextH = 1[, $AlignTextV = 1[, $ColorText = 0xFF000000[,
;                  $hFont = "Arial"[, $fSize = 9[, $iStyle = 0[, $MargeGauche = 0[, $MargeHaute = 0[, $Masq = 0]]]]]]]]])
; Parameters ....: $Left                - La coordonne X du coin suprieur gauche du contrle.
;                  $Top                 - La coordonne Y du coin suprieur gauche du contrle.
;                  $width               - Largeur du contrle
;                  $height              - Hauteur du contrle
;                  $Text                - texte du contrle.
;                  $AlignTextH          - [optional] Alignement horizontale du texte. 0=gauche 1=milieu 2= droite. Default is 1.
;                  $AlignTextV          - [optional] Alignement verticale du texte. Alignement = 0 haut, 1 milieu, 2 bas. Default is 1.
;                  $ColorText           - [optional] Couleur du texte ARGB. Default is 0xFF000000.
;                  $hFont               - [optional] Nom de la police. Default is "Arial".
;                  $fSize               - [optional] Taille de la police. Default is 9.
;                  $iStyle              - [optional] Style de la police. 0 = normal, 1 = gras, 2 = Italique, etc... Default is 0. (voir _GDIPlus_FontCreate().)
;                  $MargeGauche         - [optional] Marge sur la gauche. Default is 0.
;                  $MargeHaute          - [optional] Marge haute. Default is 0.
;                  $Masq                - [optional] Masque de couleur ARGB en superposition, eg: 0x20FFFF00. Default is 0 (pas de masque).
; Return values .: L'Id du control
; Author ........: Walkson
; Modified ......:
; Remarks .......:
; ===============================================================================================================================
Func _ADD_Button($Left, $Top, $width, $height, $Text, $AlignTextH = 1, $AlignTextV = 1, $ColorText = 0xFF000000, $hFont = "Arial", $fSize = 9, $iStyle = 0, $MargeGauche = 0, $MargeHaute = 0, $Masq = 0)
	Local $_label0 = GUICtrlCreateLabel($Text, $Left, $Top, $width, $height, $SS_BITMAP)
	Local $Hlabel = GUICtrlGetHandle($_label0)
	Local $array[6]
	$array[0] = $Hlabel ;handle
	;$array[1] Hbitmap
	;$array[2] Hbitmap hovers
	;$array[3] Hbitmap clic
	;$array[4] Hbitmap disable
	$array[5] = $_label0 ;Id
	$gFont = $hFont
	_GDIPlus_Startup() ; Initialise GDI+

	;================================================ button au repos ============================================ le relief, les bordures
	Local $hGraphics = _GDIPlus_GraphicsCreateFromHWND($Hlabel) ; Cre un objet Graphics  partir du handle de la fentre
	$g_hBitmap = _GDIPlus_BitmapCreateFromGraphics($width, $height, $hGraphics)
	$hGraphics = _GDIPlus_ImageGetGraphicsContext($g_hBitmap)
	_GDIPlus_GraphicsSetSmoothingMode($hGraphics, 4)
	_GDIPlus_GraphicsSetCompositingQuality($hGraphics, 2)
	Interpolations($width, $height, $hGraphics, 0XFFF0F0F0, 0xFFF0F0F0, 0xFFFDFDFD, 0xFF505050, 0xFFAAAAAA, 0xFF000000, 0xFFF0F0F0)
	_GDIPlus_CreateRoundedCorner($width, $height, $hGraphics, -1, 0xA60050590, 1)
	DrawRect($width, $height, $hGraphics, 0xFF9090AF)

	;========================================================================================================= le masque
	If $Masq <> 0 Then
		$hBrush = _GDIPlus_BrushCreateSolid($Masq)
		_GDIPlus_GraphicsFillRect($hGraphics, 0, 0, $width, $height, $hBrush)
		_GDIPlus_BrushDispose($hBrush)
	EndIf

	;====================================================================================== le texte
	DrawTextFormatAlign($Text, $width, $height, $hGraphics, $ColorText, $AlignTextH, $AlignTextV, $gFont, $fSize, $iStyle, $MargeGauche, $MargeHaute)

	;===================================================================================== l'arrondi
	_GDIPlus_GraphicsDrawImage($hGraphics, $g_hBitmap, 0, 0)
	$g_hBitmap = _GDIPlus_BitmapCreateRoundedCornerFromBitmap($g_hBitmap, -1, False, 0xFF000000, 1)
	$hBMP = _GDIPlus_BitmapCreateHBITMAPFromBitmap($g_hBitmap)
	$array[1] = $hBMP

	_GDIPlus_BitmapDispose($g_hBitmap)
	_GDIPlus_GraphicsDispose($hGraphics)

	;================================================ MOUSE HOVERS ============================================
	$hGraphics = _GDIPlus_GraphicsCreateFromHWND($Hlabel) ; Cre un objet Graphics  partir du handle de la fentre
	$g_hBitmap = _GDIPlus_BitmapCreateFromGraphics($width, $height, $hGraphics)
	$hGraphics = _GDIPlus_ImageGetGraphicsContext($g_hBitmap)
	_GDIPlus_GraphicsSetSmoothingMode($hGraphics, 4)
	_GDIPlus_GraphicsSetCompositingQuality($hGraphics, 2)
	Interpolations($width, $height, $hGraphics, 0XFFF0F0FB, 0xFFF0F0FB, 0xFFFEFEFD, 0xFF5050BB, 0xFFAAAAADF, 0xFF000000, 0xFFF0F0FF)
	_GDIPlus_CreateRoundedCorner($width, $height, $hGraphics, -1, 0xFF909090, 1.5)
	DrawRect($width, $height, $hGraphics, 0xDD9090AF)

	;=========================================================================================================
	If $Masq <> 0 Then
		$hBrush = _GDIPlus_BrushCreateSolid($Masq)
		_GDIPlus_GraphicsFillRect($hGraphics, 0, 0, $width, $height, $hBrush)
		_GDIPlus_BrushDispose($hBrush)
	EndIf

	;======================================================================================
	DrawTextFormatAlign($Text, $width, $height, $hGraphics, $ColorText, $AlignTextH, $AlignTextV, $gFont, $fSize, $iStyle, $MargeGauche, $MargeHaute)

	;=====================================================================================
	_GDIPlus_GraphicsDrawImage($hGraphics, $g_hBitmap, 0, 0)
	$g_hBitmap = _GDIPlus_BitmapCreateRoundedCornerFromBitmap($g_hBitmap, -1, False)
	$hBMP = _GDIPlus_BitmapCreateHBITMAPFromBitmap($g_hBitmap)
	$array[2] = $hBMP

	_GDIPlus_BitmapDispose($g_hBitmap)
	_GDIPlus_GraphicsDispose($hGraphics)

	;================================================ MOUSE CLIC ============================================
	$hGraphics = _GDIPlus_GraphicsCreateFromHWND($Hlabel) ; Cre un objet Graphics  partir du handle de la fentre
	$g_hBitmap = _GDIPlus_BitmapCreateFromGraphics($width, $height, $hGraphics)
	$hGraphics = _GDIPlus_ImageGetGraphicsContext($g_hBitmap)
	_GDIPlus_GraphicsSetSmoothingMode($hGraphics, 4)
	_GDIPlus_GraphicsSetCompositingQuality($hGraphics, 2)
	Interpolations($width, $height, $hGraphics, 0XFFA9A9BA, 0xFFB0B0DD, 0xFFFDFDFE, 0xFF404060, 0xFF202020, 0xFF101010, 0xFF000000)
	_GDIPlus_CreateRoundedCorner($width, $height, $hGraphics, -1, 0xBB000099, 1.5)
	DrawRect($width, $height, $hGraphics, 0xA03030AA)

	;=========================================================================================================
	If $Masq <> 0 Then
		$hBrush = _GDIPlus_BrushCreateSolid($Masq)
		_GDIPlus_GraphicsFillRect($hGraphics, 0, 0, $width, $height, $hBrush)
		_GDIPlus_BrushDispose($hBrush)
	EndIf

	;======================================================================================
	DrawTextFormatAlign($Text, $width, $height, $hGraphics, $ColorText, $AlignTextH, $AlignTextV, $gFont, $fSize, $iStyle, $MargeGauche, $MargeHaute)

	;=====================================================================================
	_GDIPlus_GraphicsDrawImage($hGraphics, $g_hBitmap, 0, 0)
	$g_hBitmap = _GDIPlus_BitmapCreateRoundedCornerFromBitmap($g_hBitmap, -1, False)
	$hBMP = _GDIPlus_BitmapCreateHBITMAPFromBitmap($g_hBitmap)
	$array[3] = $hBMP

	_GDIPlus_BitmapDispose($g_hBitmap)
	_GDIPlus_GraphicsDispose($hGraphics)

	;================================================ button disable ============================================
	Local $hGraphics = _GDIPlus_GraphicsCreateFromHWND($Hlabel) ; Cre un objet Graphics  partir du handle de la fentre
	$g_hBitmap = _GDIPlus_BitmapCreateFromGraphics($width, $height, $hGraphics)
	$hGraphics = _GDIPlus_ImageGetGraphicsContext($g_hBitmap)
	_GDIPlus_GraphicsSetSmoothingMode($hGraphics, 4)
	_GDIPlus_GraphicsSetCompositingQuality($hGraphics, 2)
	Interpolations($width, $height, $hGraphics, 0XFFF0F0F0, 0xFFF0F0F0, 0xFFFDFDFD, 0xFF505050, 0xFFAAAAAA, 0xFF000000, 0xFFF0F0F0)
	_GDIPlus_CreateRoundedCorner($width, $height, $hGraphics, -1, 0xFF505050, 1)

	;=========================================================================================================
	$hBrush = _GDIPlus_BrushCreateSolid(0x609A9A9A) ;masque gris
	_GDIPlus_GraphicsFillRect($hGraphics, 0, 0, $width, $height, $hBrush)
	_GDIPlus_BrushDispose($hBrush)

	;======================================================================================
	DrawTextFormatAlign($Text, $width, $height, $hGraphics, 0xFF505050, $AlignTextH, $AlignTextV, $gFont, $fSize, $iStyle, $MargeGauche, $MargeHaute)

	;=====================================================================================
	_GDIPlus_GraphicsDrawImage($hGraphics, $g_hBitmap, 0, 0)
	$g_hBitmap = _GDIPlus_BitmapCreateRoundedCornerFromBitmap($g_hBitmap, -1, False)
	$hBMP = _GDIPlus_BitmapCreateHBITMAPFromBitmap($g_hBitmap)
	$array[4] = $hBMP

	_GDIPlus_BitmapDispose($g_hBitmap)
	_GDIPlus_GraphicsDispose($hGraphics)
	_GDIPlus_Shutdown()
	If Not IsArray($array) Then Return SetError(1, 0, MsgBox(16, "erreur", @ScriptLineNumber))

	Return _POSE_Button($array[0], $array[1], $array[2], $array[3], $array[4], $array[5]) ;handle control, handle Hbitmap1, handle Hbitmap2, handle Hbitmap3, Hbitmap4, Id control

EndFunc   ;==>_ADD_Button


; #FUNCTION# ====================================================================================================================
; Name ..........: _ButtonState
; Description ...: Enable or disable control
; Syntax ........: ButtonState($CtrlId[, $enable = True])
; Parameters ....: $CtrlId              - Id du control.
;                  $enable              - True = enable, false = disable. Default is True.
; Return values .: None
; ===============================================================================================================================
Func _ButtonState($CtrlId, $enable = True)
	If Not IsBool($enable) Then Return SetError(1, 0, @ScriptLineNumber)
	$iIndex = _FindID($CtrlId)
	If $iIndex = -1 Then Return SetError(1, 0, MsgBox(0, @ScriptLineNumber, "Mauvais control"))
	Switch $enable
		Case False
			GUICtrlSetState($CtrlId, $GUI_DISABLE)
			_WinAPI_DeleteObject(_SendMessage($arrayID[$iIndex][0], $STM_SETIMAGE, 0, $arrayID[$iIndex][4]))
		Case True
			GUICtrlSetState($CtrlId, $GUI_ENABLE)
			_WinAPI_DeleteObject(_SendMessage($arrayID[$iIndex][0], $STM_SETIMAGE, 0, $arrayID[$iIndex][1]))
	EndSwitch

EndFunc   ;==>_ButtonState

; #FUNCTION# ====================================================================================================================
; Name ..........: _ButtonDelete
; Description ...: Deletes a control.
; Syntax ........: _ButtonDelete($CtrlId)
; Parameters ....: $CtrlId              - Id du control.
; Return values .: None
; ===============================================================================================================================
Func _ButtonDelete($CtrlId)
	$iIndex = _FindID($CtrlId)
	If $iIndex = -1 Then Return SetError(1, 0, MsgBox(0, @ScriptLineNumber, "Mauvais control"))
	GUICtrlDelete($CtrlId)
	_ArrayDelete($arrayID, $iIndex)
EndFunc

; #FUNCTION INTERNE# ====================================================================================================================
; #FUNCTION# ====================================================================================================================
; Name ..........: _POSE_Button
; Description ...: Fixe l'image sur le label et enregistre les handles
; Syntax ........: _POSE_Button($val0, $val1, $val2, $val3)
; Parameters ....: $val0                - handle du control
;                  $val1                - handle du Hbitmap
;                  $val2                - handle du Hbitmap Hover
;                  $val3                - handle du Hbitmap clic
;				   $val4                - handle du Hbitmap disable
;                  $val5                - Id du control
; Return values .: Id du control
; ===============================================================================================================================
Func _POSE_Button($val0, $val1, $val2, $val3, $val4, $val5)
	_ArrayAdd($arrayID, $val0 & "|" & $val1 & "|" & $val2 & "|" & $val3 & "|" & $val4 & "|" & $val5)
	_WinAPI_DeleteObject(_SendMessage($val0, $STM_SETIMAGE, 0, $val1))
	Return $arrayID[UBound($arrayID) - 1][5] ;id du label
EndFunc   ;==>_POSE_Button

Func DrawTextFormatAlign($Text, $width, $height, $hGraphics, $ColorText = 0xFF000000, $AlignTextH = 1, $AlignTextV = 1, $gFont = "Arial", $fSize = 9, $iStyle = 0, $MargeGauche = 0, $MargeHaute = 0)
	$hBrush = _GDIPlus_BrushCreateSolid($ColorText)
	$hFormat = _GDIPlus_StringFormatCreate()
	_GDIPlus_StringFormatSetAlign($hFormat, $AlignTextH) ;0=gauche 1=milieu 2= droite
	_GDIPlus_StringFormatSetLineAlign($hFormat, $AlignTextV) ; $Alignement = 0 haut, 1 milieu, 2 bas
	$hFamily = _GDIPlus_FontFamilyCreate($gFont)
	If @error Then Return SetError(10, 0, @ScriptLineNumber)
	$hFont = _GDIPlus_FontCreate($hFamily, $fSize, $iStyle)
	$tLayout = _GDIPlus_RectFCreate($MargeGauche, $MargeHaute, $width, $height)
	$aInfo = _GDIPlus_GraphicsMeasureString($hGraphics, $Text, $hFont, $tLayout, $hFormat)
	If @error Then Return SetError(1, 0, MsgBox(16, "erreur", @ScriptLineNumber))
	_GDIPlus_GraphicsSetTextRenderingHint($hGraphics, $GDIP_TEXTRENDERINGHINT_ANTIALIASGRIDFIT)
	_GDIPlus_GraphicsDrawStringEx($hGraphics, $Text, $hFont, $aInfo[0], $hFormat, $hBrush)

	_GDIPlus_FontDispose($hFont)
	_GDIPlus_FontFamilyDispose($hFamily)
	_GDIPlus_StringFormatDispose($hFormat)
	_GDIPlus_BrushDispose($hBrush)
EndFunc   ;==>DrawTextFormatAlign

Func DrawRect($width, $height, $hGraphics, $colorRect)
	$hPen1 = _GDIPlus_PenCreate($colorRect, 0.8)
	_GDIPlus_PenSetDashStyle($hPen1, $GDIP_DASHSTYLEDASH)
	If $width > $height Then
		$iRatio = Round($width / $height, 2)
	Else
		$iRatio = Round($height / $width, 2)
	EndIf
	_GDIPlus_GraphicsDrawRect($hGraphics, $iRatio, $iRatio, $width - (($iRatio * 2) + 1), $height - (($iRatio * 2) + 1), $hPen1)
	_GDIPlus_PenDispose($hPen1)
EndFunc   ;==>DrawRect

Func Interpolations($width, $height, $hGraphics, $color1, $color2, $color3, $color4, $color5, $color6, $color7)
	Local $hBrush = _GDIPlus_LineBrushCreate(0, 0, $width, $height, 0, 0, 1) ; Cre un pinceau

	Local $aInterpolations[8][2] ; Dfinit les couleurs interpoles et les emplacements
	$aInterpolations[0][0] = 7
	$aInterpolations[1][0] = $color1
	$aInterpolations[1][1] = 0 ;
	$aInterpolations[2][0] = $color2
	$aInterpolations[2][1] = 0.1 ;
	$aInterpolations[3][0] = $color3
	$aInterpolations[3][1] = 0.15 ;
	$aInterpolations[4][0] = $color4
	$aInterpolations[4][1] = 0.5 ;
	$aInterpolations[5][0] = $color5
	$aInterpolations[5][1] = 0.8 ;
	$aInterpolations[6][0] = $color6
	$aInterpolations[6][1] = 0.85 ;
	$aInterpolations[7][0] = $color7
	$aInterpolations[7][1] = 1 ; Jusqu' 100%  partir de la gauche

	_GDIPlus_LineBrushSetPresetBlend($hBrush, $aInterpolations) ; Dfinir les couleurs et les emplacements de pinceau de dgrad linaire
	$hMatrix = _GDIPlus_MatrixCreate()
	_GDIPlus_MatrixRotate($hMatrix, 90) ;couleurs  l'horizontale
	_GDIPlus_LineBrushSetTransform($hBrush, $hMatrix)
	_GDIPlus_GraphicsFillRect($hGraphics, 0, 0, $width, $height, $hBrush) ; Dessine le bitmap  l'cran
	_GDIPlus_MatrixDispose($hMatrix)
	_GDIPlus_BrushDispose($hBrush)
EndFunc   ;==>Interpolations

Func _GDIPlus_BitmapCreateRoundedCornerFromBitmap($hImage, $fRadiusCorner = -1, $bBorder = False, $iBorderColor = 0xE0FFFFFF, $iBorderSize = 1) ;coded by UEZ buid 2017-04-17
	Local $aDim = _GDIPlus_ImageGetDimension($hImage)
	If @error Then Return SetError(1, 0, 0)

	Local Const $iW = $aDim[0] + 1, $iH = $aDim[1] + 1
	Local Const $hBitmap = _GDIPlus_BitmapCreateFromScan0($iW, $iH), $hGfx = _GDIPlus_ImageGetGraphicsContext($hBitmap)
	_GDIPlus_GraphicsSetSmoothingMode($hGfx, 4)
	_GDIPlus_GraphicsSetPixelOffsetMode($hGfx, 4)
	_GDIPlus_GraphicsSetCompositingQuality($hGfx, 2)

	Local Const $hTexture = _GDIPlus_TextureCreate($hImage)
	Local Const $hPath = _GDIPlus_PathCreate()

	If $fRadiusCorner = -1 Then
		$fRadiusCorner = (($iW + $iH) / 2) * 0.1
	EndIf

	_GDIPlus_PathAddArc($hPath, $iW - ($fRadiusCorner * 2), 0, $fRadiusCorner * 2, $fRadiusCorner * 2, 270, 90)
	_GDIPlus_PathAddArc($hPath, $iW - ($fRadiusCorner * 2), $iH - ($fRadiusCorner * 2), $fRadiusCorner * 2, $fRadiusCorner * 2, 0, 90)
	_GDIPlus_PathAddArc($hPath, 0, $iH - ($fRadiusCorner * 2), $fRadiusCorner * 2, $fRadiusCorner * 2, 90, 90)
	_GDIPlus_PathAddArc($hPath, 0, 0, $fRadiusCorner * 2, $fRadiusCorner * 2, 180, 90)
	_GDIPlus_PathCloseFigure($hPath)

	_GDIPlus_GraphicsFillPath($hGfx, $hPath, $hTexture)
	If $bBorder Then
		Local Const $hPen = _GDIPlus_PenCreate($iBorderColor, $iBorderSize)
		_GDIPlus_PenSetLineJoin($hPen, 2)
		_GDIPlus_PenSetAlignment($hPen, 1)
		_GDIPlus_GraphicsDrawPath($hGfx, $hPath, $hPen)
		_GDIPlus_PenDispose($hPen)
	EndIf

	_GDIPlus_GraphicsDispose($hGfx)
	_GDIPlus_BrushDispose($hTexture)
	_GDIPlus_PathDispose($hPath)

	Return $hBitmap
EndFunc   ;==>_GDIPlus_BitmapCreateRoundedCornerFromBitmap

Func _GDIPlus_CreateRoundedCorner($iW, $iH, $hGraphics, $fRadiusCorner = -1, $iBorderColor = 0xE0FFFFFF, $iBorderSize = 1)
	Local Const $hPath = _GDIPlus_PathCreate()
	If $fRadiusCorner = -1 Then
		$fRadiusCorner = (($iW + $iH) / 2) * 0.1
	EndIf
	_GDIPlus_PathAddArc($hPath, $iW - ($fRadiusCorner * 2), 0, ($fRadiusCorner * 2), ($fRadiusCorner * 2), 270, 90)
	_GDIPlus_PathAddArc($hPath, $iW - ($fRadiusCorner * 2), $iH - ($fRadiusCorner * 2), $fRadiusCorner * 2, $fRadiusCorner * 2, 0, 90)
	_GDIPlus_PathAddArc($hPath, 0, $iH - ($fRadiusCorner * 2), $fRadiusCorner * 2, $fRadiusCorner * 2, 90, 90)
	_GDIPlus_PathAddArc($hPath, 0, 0, $fRadiusCorner * 2, $fRadiusCorner * 2, 180, 90)
	_GDIPlus_PathCloseFigure($hPath)
	Local Const $hPen = _GDIPlus_PenCreate($iBorderColor, $iBorderSize)
	_GDIPlus_PenSetLineJoin($hPen, 2)
	_GDIPlus_PenSetAlignment($hPen, 1)
	_GDIPlus_GraphicsDrawPath($hGraphics, $hPath, $hPen)
	_GDIPlus_PenDispose($hPen)
	_GDIPlus_PathDispose($hPath)
EndFunc   ;==>_GDIPlus_CreateRoundedCorner

Func _FindID($id)
	$iIndex = -1
	For $i = 0 To UBound($arrayID, 1) - 1
		If $arrayID[$i][5] = $id Then
			$iIndex = $i
			ExitLoop
		Else
			$iIndex = -1
		EndIf
	Next
	Return $iIndex
EndFunc   ;==>_FindID

Func WM_SETCURSOR($hWnd, $iMsg, $iwParam, $ilParam)
	#forceref $hWnd, $iMsg, $iwParam, $ilParam

	$hitTest = BitShift($ilParam, 16)
	$id = _WinAPI_GetDlgCtrlID($iwParam)
	$iIndex = -1
	If _WinAPI_GetClassName($iwParam) = "Static" Then
		$iIndex = _FindID($id)
		If $iIndex <> -1 Then
			Switch $iwParam
				Case $arrayID[$iIndex][0]
					Switch $hitTest
						Case $WM_LBUTTONDOWN
							_WinAPI_DeleteObject(_SendMessage($arrayID[$iIndex][0], $STM_SETIMAGE, $IMAGE_BITMAP, $arrayID[$iIndex][3]))
							Sleep(400)
						Case $WM_LBUTTONUP
							_WinAPI_DeleteObject(_SendMessage($arrayID[$iIndex][0], $STM_SETIMAGE, $IMAGE_BITMAP, $arrayID[$iIndex][2]))
					EndSwitch

			EndSwitch
		EndIf
	EndIf
	If $iwParam <> $test Then
		Select
			Case $iIndex <> -1 And _WinAPI_GetDlgCtrlID($iwParam) = $arrayID[$iIndex][5]
				_WinAPI_DeleteObject(_SendMessage($arrayID[$iIndex][0], $STM_SETIMAGE, $IMAGE_BITMAP, $arrayID[$iIndex][2]))
				$hIndex = $iIndex

			Case $hIndex >= 0
				 _WinAPI_DeleteObject(_SendMessage($arrayID[$hIndex][0], $STM_SETIMAGE, $IMAGE_BITMAP, $arrayID[$hIndex][1]))
				$hIndex = -1
		EndSelect

		$test = $iwParam
	EndIf

	Return 'GUI_RUNDEFMSG'
EndFunc   ;==>WM_SETCURSOR

Func Net()
	For $i = 0 To UBound($arrayID, 1) - 1
		_WinAPI_DeleteObject($arrayID[$i][1])
		_WinAPI_DeleteObject($arrayID[$i][2])
		_WinAPI_DeleteObject($arrayID[$i][3])
		_WinAPI_DeleteObject($arrayID[$i][4])
	Next
	$arrayID = 0
EndFunc   ;==>Net
